-- get the namespace
local _, namespace = ...;

local frame = CreateFrame("Frame")

-- Messages the selected channel with instructions based on the boss's name and boss table information
namespace.chat = {
	
	-- function that prints instructions using the current chat channel
	printInstructions = function(boss, difficulty, instructions, chatChannel)
	
		-- set print header
		messageHeader = "Boss: " .. boss .. " --- Difficulty: " .. difficulty  
		
		-- print to self if SELF is checked
		if (chatChannel == "SELF") then
			print(messageHeader)
			for i, line in ipairs(instructions) do 
				print(line)
			end
		-- otherwise say it in the appropriate chat channel
		else
			SendChatMessage(messageHeader, chatChannel, "Common", nil)
			for i, line in ipairs(instructions) do 
				SendChatMessage(line, chatChannel, "Common", nil) 
			end
		end

	end,
	
}